Index: /trunk/src/lib/graphics/effects/lense_flare.cc
===================================================================
--- /trunk/src/lib/graphics/effects/lense_flare.cc	(revision 8494)
+++ /trunk/src/lib/graphics/effects/lense_flare.cc	(revision 8495)
@@ -22,4 +22,5 @@
 #include "util/loading/factory.h"
 
+#include "glincl.h"
 #include "texture.h"
 
@@ -43,29 +44,34 @@
  * @param root The XML-element to load the LenseFlare from
  */
- LenseFlare::LenseFlare(const TiXmlElement* root)
-{
-  this->setClassID(CL_LENSE_FLARE, "LenseFlare");
-
-  this->flareMatrix = new float[14];
-  /*          length                      image scale */
-  this->flareMatrix[0] = 1.0f; this->flareMatrix[1] = 1.0f;
-  this->flareMatrix[2] = 0.5f; this->flareMatrix[3] = 0.5f;
-  this->flareMatrix[4] = 0.33f; this->flareMatrix[5] = 0.25f;
-  this->flareMatrix[6] = 0.125f; this->flareMatrix[7] = 1.0f;
-  this->flareMatrix[8] = -0.5f; this->flareMatrix[9] = 0.5f;
-  this->flareMatrix[10] = -0.25f; this->flareMatrix[11] = 0.15f;
-  this->flareMatrix[12] = -1.82f; this->flareMatrix[13] = 0.25f;
-
-  this->lightSource = (LightManager::getInstance())->getLight(0);
-  PRINTF(0)("light is: %p\n", this->lightSource);
-
-  if (root != NULL)
-  {
-    this->loadParams(root);
-    this->activate();
-  }
-
-  this->bVisible = true;
-  this->setSourceVisibility(false);
+LenseFlare::LenseFlare(const TiXmlElement* root) {
+    this->setClassID(CL_LENSE_FLARE, "LenseFlare");
+
+    this->flareMatrix = new float[14];
+    /*          length                      image scale */
+    this->flareMatrix[0] = 1.0f;
+    this->flareMatrix[1] = 1.0f;
+    this->flareMatrix[2] = 0.5f;
+    this->flareMatrix[3] = 0.5f;
+    this->flareMatrix[4] = 0.33f;
+    this->flareMatrix[5] = 0.25f;
+    this->flareMatrix[6] = 0.125f;
+    this->flareMatrix[7] = 1.0f;
+    this->flareMatrix[8] = -0.5f;
+    this->flareMatrix[9] = 0.5f;
+    this->flareMatrix[10] = -0.25f;
+    this->flareMatrix[11] = 0.15f;
+    this->flareMatrix[12] = -1.82f;
+    this->flareMatrix[13] = 0.25f;
+
+    this->lightSource = (LightManager::getInstance())->getLight(0);
+    PRINTF(0)("light is: %p\n", this->lightSource);
+
+    if (root != NULL) {
+        this->loadParams(root);
+        this->activate();
+    }
+
+    this->bVisible = true;
+    this->setSourceVisibility(false);
 
 }
@@ -75,9 +81,8 @@
  *  destroys a LenseFlare
  */
-LenseFlare::~LenseFlare()
-{
-  std::vector<ImagePlane*>::iterator it;
-  for( it = flares.begin(); it != flares.end(); it++)
-    delete (*it);
+LenseFlare::~LenseFlare() {
+    std::vector<ImagePlane*>::iterator it;
+    for( it = flares.begin(); it != flares.end(); it++)
+        delete (*it);
 }
 
@@ -86,14 +91,13 @@
  * @param root The XML-element to load the LenseFlare from
  */
-void LenseFlare::loadParams(const TiXmlElement* root)
-{
-  GraphicsEffect::loadParams(root);
-
-  LOAD_PARAM_START_CYCLE(root, element);
-  {
-    LoadParam_CYCLE(element, "add-flare-texture", this, LenseFlare, addFlare)
+void LenseFlare::loadParams(const TiXmlElement* root) {
+    GraphicsEffect::loadParams(root);
+
+    LOAD_PARAM_START_CYCLE(root, element);
+    {
+        LoadParam_CYCLE(element, "add-flare-texture", this, LenseFlare, addFlare)
         .describe("adds a lensflare texture to the engine");
-  }
-  LOAD_PARAM_END_CYCLE(element);
+    }
+    LOAD_PARAM_END_CYCLE(element);
 }
 
@@ -102,8 +106,5 @@
  * initializes the fog effect
  */
-bool LenseFlare::init()
-{
-  return true;
-}
+void LenseFlare::init() {}
 
 
@@ -111,9 +112,6 @@
  * activates the fog effect
  */
-bool LenseFlare::activate()
-{
-  this->bActivated = true;
-
-  return true;
+void LenseFlare::activate() {
+    this->bActivated = true;
 }
 
@@ -122,9 +120,6 @@
  * deactivates the fog effect
  */
-bool LenseFlare::deactivate()
-{
-  this->bActivated = false;
-
-  return true;
+void LenseFlare::deactivate() {
+    this->bActivated = false;
 }
 
@@ -134,8 +129,6 @@
  * @param mode the mode character
  */
-GLint LenseFlare::stringToFogMode(const std::string& mode)
-{
-  PRINTF(1)("NOT IMPLEMENTED");
-  return 0;
+GLint LenseFlare::stringToFogMode(const std::string& mode) {
+    return 0;
 }
 
@@ -153,41 +146,37 @@
  *  7th: Texture of the third burst
  */
-void LenseFlare::addFlare(const std::string& textureName)
-{
-  if( this->flares.size() > LF_MAX_FLARES)
-  {
-    PRINTF(2)("You tried to add more than %i lense flares, ignoring\n", LF_MAX_FLARES);
-    return;
-  }
-
-  ImagePlane* bb = new ImagePlane(NULL);
-  if (this->flares.empty())
-    bb->setLayer(E2D_LAYER_BELOW_ALL);
-  bb->setTexture(textureName);
-  bb->setSize(50, 50);
-  this->flares.push_back(bb);
-  bb->setVisibility(true);
-
-  PRINTF(4)("Added a Lenseflare ImagePlane with texture %s\n", textureName.c_str());
-
-  // the first flare belongs to the light source
-  if( this->flares.size() == 1 && this->lightSource != NULL)
-  {
-    bb->setBindNode(static_cast<PNode*>(this->lightSource));
-  }
-
-  PRINTF(4)("Finished adding\n");
-}
-
-
-void LenseFlare::setSourceVisibility(bool visibility)
-{
-   if (this->bVisible == visibility)
-     return;
-
-  std::vector<ImagePlane*>::const_iterator it;
+void LenseFlare::addFlare(const std::string& textureName) {
+    if( this->flares.size() > LF_MAX_FLARES) {
+        PRINTF(2)("You tried to add more than %i lense flares, ignoring\n", LF_MAX_FLARES);
+        return;
+    }
+
+    ImagePlane* bb = new ImagePlane(NULL);
+    if (this->flares.empty())
+        bb->setLayer(E2D_LAYER_BELOW_ALL);
+    bb->setTexture(textureName);
+    bb->setSize(50, 50);
+    this->flares.push_back(bb);
+    bb->setVisibility(true);
+
+    PRINTF(4)("Added a Lenseflare ImagePlane with texture %s\n", textureName.c_str());
+
+    // the first flare belongs to the light source
+    if( this->flares.size() == 1 && this->lightSource != NULL) {
+        bb->setBindNode(static_cast<PNode*>(this->lightSource));
+    }
+
+    PRINTF(4)("Finished adding\n");
+}
+
+
+void LenseFlare::setSourceVisibility(bool visibility) {
+    if (this->bVisible == visibility)
+        return;
+
+    std::vector<ImagePlane*>::const_iterator it;
     for(it = ++flares.begin(); it != flares.end(); it++)
-      (*it)->setVisibility(visibility);
-  this->bVisible = visibility;
+        (*it)->setVisibility(visibility);
+    this->bVisible = visibility;
 }
 
@@ -196,43 +185,40 @@
  * tick the effect
  */
-void LenseFlare::tick(float dt)
-{
-  if( unlikely(!this->bActivated || this->flares.size() == 0))
-    return;
-
-  // refetch light source information if needed
-  if( unlikely( this->lightSource == NULL))
-  {
-    this->lightSource = (LightManager::getInstance())->getLight(0);
-    if( this->flares.size() > 0)
-      this->flares[0]->setBindNode(static_cast<PNode*>(this->lightSource));
-  }
+void LenseFlare::tick(float dt) {
+    if( unlikely(!this->bActivated || this->flares.size() == 0))
+        return;
+
+    // refetch light source information if needed
+    if( unlikely( this->lightSource == NULL)) {
+        this->lightSource = (LightManager::getInstance())->getLight(0);
+        if( this->flares.size() > 0)
+            this->flares[0]->setBindNode(static_cast<PNode*>(this->lightSource));
+    }
 
     //set the frustum plane
-  if (!flares.empty())
-    this->setSourceVisibility(this->flares[0]->isVisible());
-
-
-  // always update the screen center, it could be, that the window is resized
-  this->screenCenter = Vector2D(State::getResX()/2.0f, State::getResY()/2.0f);
-
-  // flare vector is the direction from the center to the light source
-  this->flareVector = this->flares[0]->getAbsCoor2D() - this->screenCenter;
-  this->distance = this->flareVector.len();
-  this->flareVector.normalize();
-
-  // now calculate the new coordinates of the billboards
-  std::vector<ImagePlane*>::iterator it;
-  int i;
-  for( it = flares.begin(), i = 0; it != flares.end(); it++, i++)
-  {
-    // set the new position
-    if( i == 0)
-      continue;
-
-    (*it)->setAbsCoor2D( this->screenCenter + this->flareVector * this->flareMatrix[i * 2] * this->distance);
-    (*it)->setSize2D(50.0f * this->flareMatrix[i * 2 + 1], 50.0f * this->flareMatrix[i * 2 + 1]);
-    PRINTF(5)("Tick flare %i @ (%f, %f)\n", i, (*it)->getAbsCoor2D().x, (*it)->getAbsCoor2D().y);
-  }
+    if (!flares.empty())
+        this->setSourceVisibility(this->flares[0]->isVisible());
+
+
+    // always update the screen center, it could be, that the window is resized
+    this->screenCenter = Vector2D(State::getResX()/2.0f, State::getResY()/2.0f);
+
+    // flare vector is the direction from the center to the light source
+    this->flareVector = this->flares[0]->getAbsCoor2D() - this->screenCenter;
+    this->distance = this->flareVector.len();
+    this->flareVector.normalize();
+
+    // now calculate the new coordinates of the billboards
+    std::vector<ImagePlane*>::iterator it;
+    int i;
+    for( it = flares.begin(), i = 0; it != flares.end(); it++, i++) {
+        // set the new position
+        if( i == 0)
+            continue;
+
+        (*it)->setAbsCoor2D( this->screenCenter + this->flareVector * this->flareMatrix[i * 2] * this->distance);
+        (*it)->setSize2D(50.0f * this->flareMatrix[i * 2 + 1], 50.0f * this->flareMatrix[i * 2 + 1]);
+        PRINTF(5)("Tick flare %i @ (%f, %f)\n", i, (*it)->getAbsCoor2D().x, (*it)->getAbsCoor2D().y);
+    }
 }
 
@@ -241,7 +227,6 @@
  * draws the LenseFlares
  */
-void LenseFlare::draw() const
-{
-  if( !this->bActivated)
-    return;
-}
+void LenseFlare::draw() const {
+    if( !this->bActivated)
+        return;
+}
Index: /trunk/src/lib/graphics/effects/lense_flare.h
===================================================================
--- /trunk/src/lib/graphics/effects/lense_flare.h	(revision 8494)
+++ /trunk/src/lib/graphics/effects/lense_flare.h	(revision 8495)
@@ -32,8 +32,8 @@
     virtual void loadParams(const TiXmlElement* root);
 
-    virtual bool init();
+    virtual void init();
 
-    virtual bool activate();
-    virtual bool deactivate();
+    virtual void activate();
+    virtual void deactivate();
 
     virtual void draw() const;
Index: /trunk/src/lib/graphics/effects/lightening_effect.cc
===================================================================
--- /trunk/src/lib/graphics/effects/lightening_effect.cc	(revision 8494)
+++ /trunk/src/lib/graphics/effects/lightening_effect.cc	(revision 8495)
@@ -33,4 +33,6 @@
 CREATE_FACTORY(LighteningEffect, CL_LIGHTENING_EFFECT);
 
+// TODO: FIx Lightening with Fog enabled
+
 LighteningEffect::LighteningEffect(const TiXmlElement* root)
 {
@@ -42,6 +44,6 @@
 		this->loadParams(root);
 
-  if(this->lighteningActivate)
-	 this->activate();
+	if(this->lighteningActivate)
+		this->activate();
 }
 
@@ -55,79 +57,114 @@
 	WeatherEffect::loadParams(root);
 
-  LoadParam(root, "coord", this, LighteningEffect, coord);
-  LoadParam(root, "option", this, LighteningEffect, setLighteningOption);
-  LoadParam(root, "frequency", this, LighteningEffect, setFlashFrequency);
-  LoadParam(root, "const-time", this, LighteningEffect, setFlashConstTime);
-  LoadParam(root, "rising-time", this, LighteningEffect, setFlashRisingTime);
-  LoadParam(root, "size", this, LighteningEffect, setFlashSize);
-  LoadParam(root, "seed", this, LighteningEffect, setFlashSeed);
-}
-
-
-bool LighteningEffect::init()
-{
-  lighteningActivate = false;
-
-  this->time = 0.0;
-  this->flashFrequency = 1.4f;
-  this->flashConstTime = 0.5f;
-  this->flashRisingTime = 0.1f;
-
-  this->width = 400.0f;
-  this->height = 100.0f;
-  this->seedWidth = 50;
-  this->seedHeight = 50;
-  this->bNewCoordinate = false;
-
-  this->seedX = 500.f;
-  this->seedZ = 1000.0f;
-  this->seedTime = 4.0f;
-
-  this->billboard[0] = new Billboard(NULL);
-  this->billboard[0]->setTexture("maps/lightning_bolt1.png");
-  this->billboard[0]->setSize(this->width, this->height);
-  this->billboard[0]->setAbsCoor(3000,850,0);
-  this->billboard[0]->setVisibiliy(false);
-
-  this->billboard[1] = new Billboard(NULL);
-  this->billboard[1]->setTexture("maps/lightning_bolt2.png");
-  this->billboard[1]->setSize(this->width, this->height);
-  this->billboard[1]->setAbsCoor(3000,850,0);
-  this->billboard[1]->setVisibiliy(false);
-
-  this->billboard[2] = new Billboard(NULL);
-  this->billboard[2]->setTexture("maps/lightning_bolt3.png");
-  this->billboard[2]->setSize(this->width, this->height);
-  this->billboard[2]->setAbsCoor(3000,850,0);
-  this->billboard[2]->setVisibiliy(false);
-
-  this->billboard[3] = new Billboard(NULL);
-  this->billboard[3]->setTexture("maps/lightning_bolt4.png");
-  this->billboard[3]->setSize(this->width, this->height);
-  this->billboard[3]->setAbsCoor(0.0f, 50.0f, 0.0f);
-  this->billboard[3]->setVisibiliy(false);
-/*
-  this->soundSource = NULL;
-  this->thunderBuffer = NULL;
-
-  this->soundSource.setSourceNode(this);
-
-  //load sound
-  if (this->thunderBuffer != NULL)
-    ResourceManager::getInstance()->unload(this->thunderBuffer);
-  this->thunderBuffer = (OrxSound::SoundBuffer*)ResourceManager::getInstance()->load("sound/thunder.wav", WAV);*/
-
-  return true;
+	LoadParam(root, "coord", this, LighteningEffect, coord);
+	LoadParam(root, "frequency", this, LighteningEffect, setFlashFrequency);
+	LoadParam(root, "const-time", this, LighteningEffect, setFlashConstTime);
+	LoadParam(root, "rising-time", this, LighteningEffect, setFlashRisingTime);
+	LoadParam(root, "size", this, LighteningEffect, setFlashSize);
+	LoadParam(root, "seed", this, LighteningEffect, setFlashSeed);
+
+	LOAD_PARAM_START_CYCLE(root, element);
+	{
+		LoadParam_CYCLE(element, "option", this, LighteningEffect, setLighteningOption);
+	}
+	LOAD_PARAM_END_CYCLE(element);
+}
+
+
+void LighteningEffect::init()
+{
+	//default values
+	this->lighteningActivate = false;
+
+	this->time = 0.0;
+	this->flashFrequency = 4.0f;
+	this->mainFrequency = 4.0f;
+	this->flashConstTime = 0.1f;
+	this->flashRisingTime = 0.03f;
+
+	this->width = 700.0f;
+	this->height = 250.0f;
+	this->seedWidth = 50.0f;
+	this->seedHeight = 50.0f;
+	this->bNewCoordinate = false;
+  this->lighteningMove = false;
+
+	this->seedX = 500.f;
+	this->seedZ = 1000.0f;
+	this->seedTime = 2.0f;
+
+  this->mainPosX = 3000;
+  this->mainPosY = 900;
+  this->mainPosZ = 0;
+
+	// initialize lightening textures
+	this->billboard[0] = new Billboard(NULL);
+	this->billboard[0]->setTexture("maps/lightning_bolt1.png");
+	this->billboard[0]->setSize(this->width, this->height);
+	this->billboard[0]->setVisibiliy(false);
+
+	this->billboard[1] = new Billboard(NULL);
+	this->billboard[1]->setTexture("maps/lightning_bolt2.png");
+	this->billboard[1]->setSize(this->width, this->height);
+	this->billboard[1]->setVisibiliy(false);
+
+	this->billboard[2] = new Billboard(NULL);
+	this->billboard[2]->setTexture("maps/lightning_bolt3.png");
+	this->billboard[2]->setSize(this->width, this->height);
+	this->billboard[2]->setVisibiliy(false);
+
+	this->billboard[3] = new Billboard(NULL);
+	this->billboard[3]->setTexture("maps/lightning_bolt4.png");
+	this->billboard[3]->setSize(this->width, this->height);
+	this->billboard[3]->setVisibiliy(false);
+
+	if (this->lighteningMove) {
+		this->cameraCoor = State::getCameraNode()->getAbsCoor();
+		this->billboard[0]->setAbsCoor(this->cameraCoor.x+3000,900,this->cameraCoor.z+0);
+		this->billboard[1]->setAbsCoor(this->cameraCoor.x+3000,900,this->cameraCoor.z+0);
+		this->billboard[2]->setAbsCoor(this->cameraCoor.x+3000,900,this->cameraCoor.z+0);
+		this->billboard[3]->setAbsCoor(this->cameraCoor.x+3000,900,this->cameraCoor.z+0);
+	} else {
+		this->billboard[0]->setAbsCoor(3000,900,0);
+		this->billboard[1]->setAbsCoor(3000,900,0);
+		this->billboard[2]->setAbsCoor(3000,900,0);
+		this->billboard[3]->setAbsCoor(3000,900,0);
+	}
+
+	this->flashLight = new Light();
+	this->flashLight->setDiffuseColor(0,0,0);
+	this->flashLight->setSpecularColor(0,0,0);
+
+	/*
+	this->soundSource = NULL;
+	this->thunderBuffer = NULL;
+
+	this->soundSource.setSourceNode(this);
+
+	//load sound
+	if (this->thunderBuffer != NULL)
+	ResourceManager::getInstance()->unload(this->thunderBuffer);
+	this->thunderBuffer = (OrxSound::SoundBuffer*)ResourceManager::getInstance()->load("sound/thunder.wav", WAV);*/
+
 }
 
 void LighteningEffect::coord(float x, float y, float z)
 {
-  this->billboard[0]->setAbsCoor(x, y, z);
-  this->billboard[1]->setAbsCoor(x, y, z);
-  this->billboard[2]->setAbsCoor(x, y, z);
-  this->billboard[3]->setAbsCoor(x, y, z);
-  this->mainPosX = x;
-  this->mainPosY = y;
-  this->mainPosZ = z;
+	if (this->lighteningMove) {
+		this->cameraCoor = State::getCameraNode()->getAbsCoor();
+		this->billboard[0]->setAbsCoor(this->cameraCoor.x+x, y, this->cameraCoor.z+z);
+		this->billboard[1]->setAbsCoor(this->cameraCoor.x+x, y, this->cameraCoor.z+z);
+		this->billboard[2]->setAbsCoor(this->cameraCoor.x+x, y, this->cameraCoor.z+z);
+		this->billboard[3]->setAbsCoor(this->cameraCoor.x+x, y, this->cameraCoor.z+z);
+	} else {
+		this->billboard[0]->setAbsCoor(x, y, z);
+		this->billboard[1]->setAbsCoor(x, y, z);
+		this->billboard[2]->setAbsCoor(x, y, z);
+		this->billboard[3]->setAbsCoor(x, y, z);
+	}
+
+	this->mainPosX = x;
+	this->mainPosY = y;
+	this->mainPosZ = z;
 }
 
@@ -135,108 +172,124 @@
 void LighteningEffect::setFlashSize(float width, float height, float seedWidth, float seedHeight)
 {
-  this->width = width;
-  this->height = height;
-  this->seedWidth = seedWidth;
-  this->seedHeight = seedHeight;
-  this->billboard[0]->setSize(this->width, this->height);
-  this->billboard[1]->setSize(this->width, this->height);
-  this->billboard[2]->setSize(this->width, this->height);
-  this->billboard[3]->setSize(this->width, this->height);
-}
-
-
-bool LighteningEffect::activate()
+	this->width = width;
+	this->height = height;
+	this->seedWidth = seedWidth;
+	this->seedHeight = seedHeight;
+
+	this->billboard[0]->setSize(this->width, this->height);
+	this->billboard[1]->setSize(this->width, this->height);
+	this->billboard[2]->setSize(this->width, this->height);
+	this->billboard[3]->setSize(this->width, this->height);
+}
+
+
+void LighteningEffect::activate()
 {
 	PRINTF(0)( "Activating LighteningEffect\n" );
-  this->time = 0;
-  lighteningActivate = true;
-
-  return true;
-}
-
-
-bool LighteningEffect::deactivate()
+	this->lighteningActivate = true;
+
+	this->time = 0;
+}
+
+
+void LighteningEffect::deactivate()
 {
 	PRINTF(0)("Deactivating LighteningEffect\n");
-  this->billboard[0]->setVisibiliy(false);
-  this->billboard[1]->setVisibiliy(false);
-  this->billboard[2]->setVisibiliy(false);
-  this->billboard[3]->setVisibiliy(false);
-  lighteningActivate = false;
-
-
-  return true;
+	this->lighteningActivate = false;
+
+	this->billboard[0]->setVisibiliy(false);
+	this->billboard[1]->setVisibiliy(false);
+	this->billboard[2]->setVisibiliy(false);
+	this->billboard[3]->setVisibiliy(false);
 }
 
 void LighteningEffect::tick (float dt)
 {
-  if(!lighteningActivate)
-    return;
-
-  this->time += dt;
-
-  /*if( flashLight != NULL)
-  {
-    if((int)(100*time)%2)
-      this->flashLight->setDiffuseColor(0,0,0);
-    else
-      this->flashLight->setDiffuseColor(100,100,100);
-
-    //PRINTF(0)("100*time: %f %i\n", 100*time, (int)(100*time));
-}*/
-
-  if( this->time > this->flashFrequency)
-  {
-    this->billboard[0]->setVisibiliy(true);
-    this->time = 0.0f;
-
-    this->flashLight = new Light();
-    this->flashLight->setAbsCoor(this->billboard[0]->getAbsCoor().x, this->billboard[0]->getAbsCoor().y, this->billboard[0]->getAbsCoor().z);
-    this->flashLight->setDiffuseColor(100,100,100);
-
-    //this->soundSource.play(this->thunderBuffer);
-  }
-  else if( this->billboard[3]->isVisible() && this->time > this->flashConstTime)
-  {
-    this->billboard[3]->setVisibiliy(false);
-    this->time = 0.0f;
-    this->bNewCoordinate = true;
-
-    if(flashLight != NULL)
-    {
-      delete this->flashLight;
-      flashLight = NULL;
-    }
-  }
-
-  if( this->billboard[2]->isVisible() && this->time > this->flashRisingTime)
-  {
-    this->billboard[2]->setVisibiliy(false);
-    this->billboard[3]->setVisibiliy(true);
-    this->flashLight->setDiffuseColor(100,100,100);
-  }
-  else if( this->billboard[1]->isVisible() && this->time > this->flashRisingTime*2/3 )
-  {
-    this->billboard[1]->setVisibiliy(false);
-    this->billboard[2]->setVisibiliy(true);
-    this->flashLight->setDiffuseColor(0,0,0);
-  }
-  else if( this->billboard[0]->isVisible() && this->time > this->flashRisingTime*1/3 )
-  {
-    this->billboard[0]->setVisibiliy(false);
-    this->billboard[1]->setVisibiliy(true);
-    this->flashLight->setDiffuseColor(100,100,100);
-  }
-
-  if( this->bNewCoordinate)
-  {
-    float posX = this->mainPosX - this->seedX * (float)rand()/(float)RAND_MAX;
-    float posZ = this->mainPosZ + this->seedZ * (float)rand()/(float)RAND_MAX;
-    this->billboard[0]->setAbsCoor(posX, this->mainPosY, posZ);
-    this->billboard[1]->setAbsCoor(posX, this->mainPosY, posZ);
-    this->billboard[2]->setAbsCoor(posX, this->mainPosY, posZ);
-    this->billboard[3]->setAbsCoor(posX, this->mainPosY, posZ);
-    this->bNewCoordinate = false;
-  }
+	if(!lighteningActivate)
+		return;
+
+	this->time += dt;
+
+	// TODO: Make random flashing with short light dingsda:)
+
+	if( this->time > this->flashFrequency) {
+
+		this->billboard[0]->setVisibiliy(true);
+		this->time = 0.0f;
+
+		this->flashLight->setAbsCoor(this->billboard[0]->getAbsCoor().x, this->billboard[0]->getAbsCoor().y, this->billboard[0]->getAbsCoor().z);
+
+		// flash environmental lightening
+		this->flashLight->setDiffuseColor(1,1,1);
+		this->flashLight->setSpecularColor(1,1,1);
+
+		//this->soundSource.play(this->thunderBuffer);
+
+	} else if( this->billboard[3]->isVisible() && this->time > this->flashConstTime) {
+
+		this->billboard[3]->setVisibiliy(false);
+		this->time = 0.0f;
+		this->flashLight->setDiffuseColor(0,0,0);
+		this->flashLight->setSpecularColor(0,0,0);
+		this->bNewCoordinate = true;
+
+	}
+
+	if( this->billboard[2]->isVisible() && this->time > this->flashRisingTime) {
+
+		this->billboard[2]->setVisibiliy(false);
+		this->billboard[3]->setVisibiliy(true);
+		// this->flashLight->setDiffuseColor(1,1,1);
+		// this->flashLight->setSpecularColor(1,1,1);
+
+	} else if( this->billboard[1]->isVisible() && this->time > this->flashRisingTime*2/3 ) {
+
+		this->billboard[1]->setVisibiliy(false);
+		this->billboard[2]->setVisibiliy(true);
+		//this->flashLight->setDiffuseColor(0,0,0);
+		//this->flashLight->setSpecularColor(0,0,0);
+
+	} else if( this->billboard[0]->isVisible() && this->time > this->flashRisingTime*1/3 ) {
+
+		this->billboard[0]->setVisibiliy(false);
+		this->billboard[1]->setVisibiliy(true);
+		//this->flashLight->setDiffuseColor(1,1,1);
+		//this->flashLight->setSpecularColor(1,1,1);
+
+	}
+
+	if( this->bNewCoordinate) {
+		float posX, posZ;
+
+		if(this->lighteningMove) {
+
+			this->cameraCoor = State::getCameraNode()->getAbsCoor();
+			posX = this->mainPosX - this->seedX * (float)rand()/(float)RAND_MAX + this->cameraCoor.x;
+			posZ = this->mainPosZ + this->seedZ * (float)rand()/(float)RAND_MAX + this->cameraCoor.z;
+
+		} else {
+
+			posX = this->mainPosX - this->seedX * (float)rand()/(float)RAND_MAX;
+			posZ = this->mainPosZ + this->seedZ * (float)rand()/(float)RAND_MAX;
+
+		}
+
+		this->billboard[0]->setAbsCoor(posX, this->mainPosY, posZ);
+		this->billboard[1]->setAbsCoor(posX, this->mainPosY, posZ);
+		this->billboard[2]->setAbsCoor(posX, this->mainPosY, posZ);
+		this->billboard[3]->setAbsCoor(posX, this->mainPosY, posZ);
+
+		this->flashFrequency = this->mainFrequency + this->seedTime * (float)rand()/(float)RAND_MAX;
+
+		float w = this->width + this->seedWidth * (float)rand()/(float)RAND_MAX;
+		float h = this->height + this->seedHeight * (float)rand()/(float)RAND_MAX;
+
+		this->billboard[0]->setSize(w, h);
+		this->billboard[1]->setSize(w, h);
+		this->billboard[2]->setSize(w, h);
+		this->billboard[3]->setSize(w, h);
+
+		this->bNewCoordinate = false;
+	}
 }
 
Index: /trunk/src/lib/graphics/effects/lightening_effect.h
===================================================================
--- /trunk/src/lib/graphics/effects/lightening_effect.h	(revision 8494)
+++ /trunk/src/lib/graphics/effects/lightening_effect.h	(revision 8495)
@@ -14,5 +14,4 @@
 #include "sound_source.h"
 
-
 class Billboard;
 class Light;
@@ -26,57 +25,76 @@
 		virtual void loadParams(const TiXmlElement* root);
 
-		virtual bool init();
+		virtual void init();
 
-		virtual bool activate();
-		virtual bool deactivate();
+		virtual void activate();
+		virtual void deactivate();
 
-    virtual void draw() const;
-    virtual void tick(float dt);
-    
-    void coord(float x, float y, float z);
-    void setFlashSize(float width, float height, float seedWidth, float seedHeight);
-    
-    inline void setLighteningOption(const std::string& option) { if (option == "activate") this->lighteningActivate = true;}
-    inline void setFlashFrequency(float flashFrequency) { this->flashFrequency = flashFrequency; }
-    inline void setFlashConstTime(float flashConstTime) { this->flashConstTime = flashConstTime; }
-    inline void setFlashRisingTime(float flashRisingTime) { if(flashRisingTime > this->flashConstTime)
-                                                                                        this->flashRisingTime = this->flashConstTime/2;
-                                                                                      else
-                                                                                        this->flashRisingTime = flashRisingTime; }
-    inline void setFlashSeed(float seedX, float seedZ, float seedTime) { this->seedX = seedX;
-                                                                                                         this->seedZ = seedZ;
-                                                                                                         this->seedTime = seedTime; }
+		inline  void activateLightening() { this->activate(); }
+		inline  void deactivateLightening() { this->deactivate(); }
 
-    void activateLightening() { this->activate(); }
-    void deactivateLightening() { this->deactivate(); }
-    
+		virtual void draw() const;
+		virtual void tick(float dt);
+		
+		void coord(float x, float y, float z);
+		void setFlashSize(float width, float height, float seedWidth, float seedHeight);
+		
+		inline void setLighteningOption(const std::string& option) {
+			if (option == "activate") this->lighteningActivate = true;
+			if (option == "movelightening") this->lighteningMove = true;
+		}
+
+		inline void setFlashFrequency(float mainFrequency, float seedTime) {
+			this->mainFrequency = mainFrequency;
+			this->flashFrequency = mainFrequency;
+			this->seedTime = seedTime;
+		}
+		
+		inline void setFlashConstTime(float flashConstTime) { this->flashConstTime = flashConstTime; }
+
+		inline void setFlashRisingTime(float flashRisingTime) {
+			if(flashRisingTime > this->flashConstTime)
+				this->flashRisingTime = this->flashConstTime/2;
+			else
+				this->flashRisingTime = flashRisingTime;
+		}
+		
+		inline void setFlashSeed(float seedX, float seedZ) {
+			this->seedX = seedX;
+			this->seedZ = seedZ;
+		}
+		
+
 	private:
-    Billboard* billboard[4];
-    bool lighteningActivate;
-
-    float flashFrequency;
-    float flashConstTime;
-    float flashRisingTime;
-
-    float time;
-
-    bool  bNewCoordinate;
-    float width;
-    float height;
-    float seedWidth;
-    float seedHeight;
-
-    float seedX;
-    float seedZ;
-    float seedTime;
-    
-    float mainPosX;
-    float mainPosY;
-    float mainPosZ;
-
-    Light* flashLight;
-    
-    //OrxSound::SoundSource    soundSource;
-    //OrxSound::SoundBuffer*   thunderBuffer;
+		Billboard* billboard[4];
+		bool lighteningActivate;
+		bool lighteningMove;
+		
+		float flashFrequency;
+		float mainFrequency;
+		float flashConstTime;
+		float flashRisingTime;
+		
+		float time;
+		
+		bool  bNewCoordinate;
+		float width;
+		float height;
+		float seedWidth;
+		float seedHeight;
+		
+		float seedX;
+		float seedZ;
+		float seedTime;
+		
+		float mainPosX;
+		float mainPosY;
+		float mainPosZ;
+		
+		Vector cameraCoor;
+		
+		Light* flashLight;
+		
+		//OrxSound::SoundSource    soundSource;
+		//OrxSound::SoundBuffer*   thunderBuffer;
 
 };
